#include <stdio.h>
#include "mini58series.h"
#include "BL55072A.h"
#include "hardware_init.h"
#include "CC2530_transparent_analyze.h"
#include "control_comm.h"
#include "display_common.h"
								
u16 guSetkeyScanTime 							= SyskeyScanTimer;
u8 gKeyEventCNT[KeyTotalNum]        			= {0,0,0,0,0,0};//ɨ¼
u8 KeyEventBuffer[KeyTotalNum][KeyEventBufferNum]       	= {0};

KeyScan_t gKey1_Button_t      = { High, High, NULL, NULL }; 
KeyScan_t gKey_Button_t[KeyTotalNum] = { { High, High, NULL, NULL },{ High, High, NULL, NULL },{ High, High, NULL, NULL },\
										 { High, High, NULL, NULL },{ High, High, NULL, NULL },{ High, High, NULL, NULL },};

#define KEY1_SUPPORT_EVENT  { 	{ButtonShortEvent,ButtonLongEvent,ButtonLongUpEvent,Button10sLongEvent,Button10sLongUpEvent},\
								{ButtonShortEvent,ButtonLongEvent,ButtonLongUpEvent,Button10sLongEvent,Button10sLongUpEvent},\
								{ButtonShortEvent,ButtonLongEvent,ButtonLongUpEvent,Button10sLongEvent,Button10sLongUpEvent}}
#define KEY2_SUPPORT_EVENT  { 	{ButtonShortEvent,Button10sLongEvent,Button10sLongUpEvent},\
								{ButtonShortEvent},\
								{ButtonShortEvent,Button10sLongEvent,Button10sLongUpEvent}}
#define KEY3_SUPPORT_EVENT  { 	{ButtonShortEvent,ButtonLongEvent,ButtonLongUpEvent,Button10sLongEvent,Button10sLongUpEvent},\
								{ButtonShortEvent,ButtonLongEvent,ButtonLongUpEvent,Button10sLongEvent,Button10sLongUpEvent},\
								{ButtonShortEvent,ButtonLongEvent,ButtonLongUpEvent,Button10sLongEvent,Button10sLongUpEvent}}
#define KEY4_SUPPORT_EVENT  { 	{ButtonShortEvent},\
								{ButtonShortEvent},\
								{ButtonShortEvent}}
#define KEY5_SUPPORT_EVENT  { 	{ButtonShortEvent,Button0_5sLongEvent,Button0_5sLongUpEvent},\
								{ButtonShortEvent,Button0_5sLongEvent,Button0_5sLongUpEvent},\
								{ButtonShortEvent}}
#define KEY6_SUPPORT_EVENT  { 	{ButtonShortEvent,Button0_5sLongEvent,Button0_5sLongUpEvent},\
								{ButtonShortEvent,Button0_5sLongEvent,Button0_5sLongUpEvent},\
								{ButtonShortEvent}}		
						 
KeyConfigInit_t gKey_Button_Config[]     = {   { 1, P3, BIT6, High,{5,5,5},KEY1_SUPPORT_EVENT},\
											   { 2, P3, BIT1, High,{3,1,3},KEY2_SUPPORT_EVENT},\
											   { 3, P3, BIT0, High,{5,5,5},KEY3_SUPPORT_EVENT},\
											   { 4, P0, BIT7, High,{1,1,1},KEY4_SUPPORT_EVENT},\
											   { 5, P0, BIT5, High,{3,3,1},KEY5_SUPPORT_EVENT},\
											   { 6, P0, BIT1, High,{3,3,1},KEY6_SUPPORT_EVENT}\
};
u8 boad_test_falg[6]    = {0,0,0,0,0,0};				//index 0 - 5ֱ1 - 6

KEY_OPERATE  sKey_Operation[3] = {0};
#if 1
TAP_CONTROL_ST  Tap_Control = {6,{0,0,0,0,0,0},{0,0,0,0,0,0},0,0} ;
#else
#endif
//KeyProcessCallback  KeyProcess_Handler_Callbacks = NULL;

static void KEY1_Botton_Process_Handler(u8 KeyPressEvent);
static void KEY2_Botton_Process_Handler(u8 KeyPressEvent);
static void KEY3_Botton_Process_Handler(u8 KeyPressEvent);
static void KEY4_Botton_Process_Handler(u8 KeyPressEvent);
static void KEY5_Botton_Process_Handler(u8 KeyPressEvent);
static void KEY6_Botton_Process_Handler(u8 KeyPressEvent);

void KeyProcess_Handler_Callbacks(u8 key_id,u8 KeyPressEvent);
u8 Get_NextOne_By_Current_Speed_Level(u8 plus_or_sub,u8 fan_speed,u8 type_support);
u8 Get_NextOne_By_Current_wind_direct(u8 plus_or_sub,u8 wind_direct);
static void Tap_Status_Scan_Task_Start(void);

extern BACKLIGHT_CONTROL sBacklight;

extern  Lcd_Status_Info_t  LCDShowTemp_state_t;

u8   First_Exit_Factory_Mode = 0;

#if DEVICE_TYPE_FAN
u8 auto_time = 0;
u8 auto_type = 0;
#endif
/*
10S 
*/
static _Bool LongLongPress10s_Handler(u8 keyid,u8 KeyPressEvent)
{
	//ϻ
	static u32 last_time = 0;
	static u8 first_10s_press = 0;
	if((keyid == 1) &&(KeyPressEvent == Button10sLongEvent))
	{
		if(Oled_Display_Info.aging_test_flag != 2) 
		{
			Spake_Start();
			if( ((Oled_Display_Info.local_timer -  last_time) <= 20*1000)&&first_10s_press )
			{
				first_10s_press = 0;
				//ָʾ˸һ
				kNetIndicatorOptTrigger(7, 200,200, 5*1000/(200+200),0,1 );
				LCD_CONTROL(1);
				BL55072A_DisplayALL();
				Oled_Display_Info.aging_test_flag = 2;		//д־λ
				First_Exit_Factory_Mode  = 1; 
				save_data();	
				aging_test_stop();							//ֹͣϻ¼
				task_exit_aging_test_start();				
				return TRUE;
			}
			else
			{
				first_10s_press = 1;
				last_time = Oled_Display_Info.local_timer;
				//ָʾ˸һ
				if(LED1)
					kNetIndicatorOptTrigger(7, 200,200, 1,0,1 );
				else
					kNetIndicatorOptTrigger(7, 200,200, 1,1,0 );
			}
		}
	}
	//ϴ¼
	if((keyid == 2) &&(KeyPressEvent == Button10sLongEvent))
	{
		if(Oled_Display_Info.screen_page == AIR_CONDITION)
		{
			if(Oled_Display_Info.Air_Device.on_off)
			{
				if(Oled_Display_Info.Air_Device.error == 3)
				{
					Oled_Display_Info.Air_Device.error = 0;
					Display_Middle_Contend(AIR_CONDITION);
					Oled_Display_Info.Air_Device.filter_wash_time = 3000;
					save_data();																			//ʱ
					state_change_report(OPCODE_GENERAL_REPORT_STATUS,1);									//״̬ϱ
					return TRUE;
				
				}
			}	
		}	
		else if(Oled_Display_Info.screen_page == FAN)
		{
			if(Oled_Display_Info.FAN_Device.on_off)
			{
				if(Oled_Display_Info.FAN_Device.error == 3)
				{
					Oled_Display_Info.FAN_Device.error = 0;
					Display_Middle_Contend(FAN);
					Oled_Display_Info.FAN_Device.filter_wash_time = 3000;
					save_data();																			//ʱ
					state_change_report(OPCODE_GENERAL_REPORT_STATUS,3);									//״̬ϱ
					return TRUE;					
				}
			}	
		
		}
	}
	return FALSE;
}
static u8 Get_Key_Pin_By_Index(u8 index)
{
	u8 Key_Pin = 0;
	switch(index)
	{
		case 0:
			Key_Pin = KEY1;
			break;
		case 1:
			Key_Pin = KEY2;
			break;
		case 2:
			Key_Pin = KEY3;
			break;
		case 3:
			Key_Pin = KEY4;
			break;
		case 4:
			Key_Pin = KEY5;
			break;
		case 5:
			Key_Pin = KEY6;
			break;
	}
	return Key_Pin;
}	
/*
밴ɨٶ
*/
void SetkeyScanTime(u16 uSetkeyScanTime)
{
    guSetkeyScanTime = uSetkeyScanTime;
}

u16 GetkeyScanTime( void )
{
    return guSetkeyScanTime;
}
static void ButtonLongEvent_Init(KeyConfigInit_t *Key_Config,u8 Key_Total_Num)
{
	u8 index = 0;
	for(index = 0;index < Key_Total_Num;index++)
	{
		GPIO_SetMode(Key_Config->port,Key_Config->u32Pin,GPIO_MODE_QUASI);
	}


}
void InputButtonInit(void)
{
	ButtonLongEvent_Init(gKey_Button_Config,sizeof(gKey_Button_Config)/sizeof(gKey_Button_Config[0]));
	
	GPIO_SetMode(P5, BIT5, GPIO_MODE_OUTPUT);/* LED1   ģʽ Mode button */
	GPIO_SetMode(P3, BIT2, GPIO_MODE_OUTPUT);/* LED2   ٰ Wind speed button */
    GPIO_SetMode(P5, BIT4, GPIO_MODE_OUTPUT);/* LED3   ʱ Timing button */	
    GPIO_SetMode(P0, BIT6, GPIO_MODE_OUTPUT);/* LED4   ذ Switch button */
    GPIO_SetMode(P0, BIT4, GPIO_MODE_OUTPUT);/* LED5   ð Setting button */
	GPIO_SetMode(P0, BIT0, GPIO_MODE_OUTPUT);/* LED6   ð Setting button */
	
    GPIO_SetMode(P1, BIT0, GPIO_MODE_OUTPUT); //K1
    GPIO_SetMode(P2, BIT4, GPIO_MODE_OUTPUT); //K2
//  GPIO_SetMode(P1, BIT3, GPIO_MODE_OUTPUT); //K3
//  GPIO_SetMode(P2, BIT4, GPIO_MODE_OUTPUT); //K4	
    GPIO_SetMode(P2, BIT6, GPIO_MODE_OUTPUT); //K5
	
	#if DEVICE_TYPE_FAN
	//ϻɣconfig K3,K4 relay
	if(Oled_Display_Info.aging_test_flag == 2)
	{
		GPIO_SetMode(P1, BIT3, GPIO_MODE_OUTPUT); //K3
		GPIO_SetMode(P1, BIT2, GPIO_MODE_OUTPUT); //K4	
		
		//K3   = 1;								//ĬԶ
		K4   = 0;
	}
	#endif
	
	
	GPIO_SetMode(P5, BIT2, GPIO_MODE_OUTPUT); //LCD CONTROL
	P52 = 0;

	
	LED1 = 0;
	LED2 = 0;
	LED3 = 0;
	LED4 = 0;
	LED5 = 0;
	LED6 = 0;
	
	K1   = 0;
	K2   = 0;
//	K3   = 0;
//	K4   = 0;
	K5   = 0;
}

/*
洢ɨ¼
*/
u8 InputKeyEvent(u8 Key_index,u8 Event)
{
        
	if( KeyEventBufferNum >= gKeyEventCNT[Key_index] )
	{
		KeyEventBuffer[Key_index][gKeyEventCNT[Key_index]] = Event;
		//printf("gKeyEventCNT[%x] = 0x%x; KeyEventBuffer[gKeyEventCNT] = 0x%x\n",Key_index,gKeyEventCNT[Key_index],Event);  
		gKeyEventCNT[Key_index] ++;		
	}
	else
	{
		//printf("Lost KeyEventBuffer = 0x%x",Event);
		return 0xff;               
	}
            
    return NoButtonEvent;
}
u8 GetKeyEvent(u8 index )
{
    u8 uReturnEvent = NoButtonEvent;
    u8 i = NULL;

	if(gKeyEventCNT[index])
	{
		uReturnEvent = KeyEventBuffer[index][0];
		gKeyEventCNT[index]--;                             //±λ

		for(i = NULL; i < gKeyEventCNT[index]; i++)        //
		{
			KeyEventBuffer[index][i] = KeyEventBuffer[index][i+1];
		}
		//printf("GetKeyEvent,index %x uReturnEvent = 0x%x\r\n",index,KeyEventBuffer[index][0]);     
		 
	}
	else
	{
		uReturnEvent = NoButtonEvent;
	}

    return uReturnEvent;     
}
u8 IS_Valided_KeyEvent(u8 KeyID,u8 KeyEvent)
{
	u8 i = 0;
	for(i=0;i<gKey_Button_Config[KeyID-1].Key_Support_Event_Num[Oled_Display_Info.screen_page-1];i++)
	{
		if(gKey_Button_Config[KeyID-1].Key_Support_Event_List[Oled_Display_Info.screen_page-1][i] == KeyEvent)
			return TRUE;;
	}
	return FALSE;
}
u8 KeyScanState( KeyScan_t* Buttion_T,u8 keyid,u8 ButtonState )
{
    u8 EventReturn = NoButtonEvent;
    static uint8_t count[6] = {0};
	static uint8_t count_0_5s[6] = {0};
    //printf("ButtonState = 0x%x\n",ButtonState);
    
    Buttion_T->LastState = ButtonState;

    ///**** ̰¼         ****/
    if( 
          (High == Buttion_T->LastState )
        &&( Low == Buttion_T->PreState )
        &&( AntiShakeTime < Buttion_T->KeyTime )
        &&( PressLongTime > Buttion_T->KeyTime)
        &&( ButtonLongEvent != (Buttion_T->PreKeyEvent))
		&&(Button10sLongEvent != (Buttion_T->PreKeyEvent))	)
    {
		if(IS_Valided_KeyEvent(keyid,ButtonShortEvent))
		{
			Buttion_T->KeyTime = NULL;
			Buttion_T->PreKeyEvent = ButtonShortEvent;
			EventReturn = ButtonShortEvent;
		}
    }
	///*****  0.5s¼         ****/
	if(  (Low == Buttion_T->LastState )&&(  Press0_5sLongTime <= (Buttion_T->KeyTime) )&&(Oled_Display_Info.screen_page !=3)&&((keyid == 5)||(keyid == 6)))
    {
		Buttion_T->KeyTime = NULL;
		count_0_5s[keyid-1]++;
		if(count_0_5s[keyid-1] >= 2)
		{
			if(IS_Valided_KeyEvent(keyid,Button0_5sLongEvent))
			{
				Buttion_T->PreKeyEvent = Button0_5sLongEvent;
				EventReturn = Button0_5sLongEvent;
			}
		}
	}
	///*****  2s¼         ****/
    if( 
          ( Low == Buttion_T->LastState )
        &&(  (PressLongTime/2) <= (Buttion_T->KeyTime) )

    )
    {
        Buttion_T->KeyTime = NULL;
		count[keyid-1]++;
		if(count[keyid-1] == 5)				//10s
		{
			if(IS_Valided_KeyEvent(keyid,Button10sLongEvent))
			{
				Buttion_T->PreKeyEvent = Button10sLongEvent;
				EventReturn = Button10sLongEvent;//InputKeyEvent( Key_Button, ModeButtonLongEvent );
			}
		}
		else if(count[keyid-1] == 2)			//4s
		{
			if(IS_Valided_KeyEvent(keyid,ButtonLongEvent))
			{
				//ϻǰЧ10sЧ
				if((keyid == 1)&&(Oled_Display_Info.aging_test_flag != 2))
					__NOP;
				else{
					Buttion_T->PreKeyEvent = ButtonLongEvent;
					EventReturn = ButtonLongEvent;//InputKeyEvent( Key_Button, ModeButtonLongEvent );
				}
			}
		}
    }
	
    ///**** ʱжϳ/̰¼                      *****/

    if( ( Low == Buttion_T->LastState ))// && ( Buttion_T->KeyTime < PressLongTime ) )
    {
        Buttion_T->KeyTime++;
    }
    else
    {
		
        Buttion_T->KeyTime = NULL;
		
		if((count_0_5s[keyid-1]>=2)&&(Button0_5sLongEvent == (Buttion_T->PreKeyEvent)))
		{
			if(IS_Valided_KeyEvent(keyid,Button0_5sLongUpEvent))
			{
				Buttion_T->PreKeyEvent = Button0_5sLongUpEvent;
				EventReturn = Button0_5sLongUpEvent;
			}
		}
		count_0_5s[keyid-1] = 0;
		
        if( ButtonLongEvent == (Buttion_T->PreKeyEvent) )
        {
			if(IS_Valided_KeyEvent(keyid,ButtonLongUpEvent))
			{
				Buttion_T->PreKeyEvent = ButtonLongUpEvent;
				EventReturn = ButtonLongUpEvent;
			}
        }
		else if(Button10sLongEvent == (Buttion_T->PreKeyEvent))
		{
			if(IS_Valided_KeyEvent(keyid,ButtonLongUpEvent))
			{
				Buttion_T->PreKeyEvent = Button10sLongUpEvent;
				EventReturn = Button10sLongUpEvent;
			}
		}
		count[keyid-1] = 0;
    }
    ///**** ״̬       *****/
    if( Buttion_T->LastState != Buttion_T->PreState )  Buttion_T->PreState = Buttion_T->LastState;
	
    return EventReturn;
}

void key_scan(void)
{
    static u8 EventTemp[KeyTotalNum] = {NoButtonEvent,NoButtonEvent,NoButtonEvent,NoButtonEvent,NoButtonEvent,NoButtonEvent};
	u8 i = 0;
    memset(EventTemp,0,sizeof(EventTemp));  
    if(!GetkeyScanTime())
    {
        SetkeyScanTime(SyskeyScanTimer);
		for(i = 0;i<KeyTotalNum;i++)
		{
			if( NoButtonEvent != (EventTemp[i] = KeyScanState( &gKey_Button_t[i],i+1, Get_Key_Pin_By_Index(i) ))  )   
			{
				InputKeyEvent(i,EventTemp[i]);
			}
		}
	}
	for(i = 0;i<KeyTotalNum;i++)
	{
		u8 KeyEventTemp = GetKeyEvent(i);
		if(!KeyEventTemp)
			continue;
		boad_test_falg[i]  = 1;							//⹦
		KeyProcess_Handler_Callbacks((i+1),KeyEventTemp);

	}
}
static u8 Is_Valided_Key(u8 device_type,u8 keyid,u8 KeyPressEvent)
{
	u8 ret = FALSE;
	switch(device_type)
	{
		case 1:
		{
			if((Oled_Display_Info.Air_Device.lock_flage)&&(keyid == 3))
				ret =  TRUE;
			else if((Oled_Display_Info.Air_Device.lock_flage==0)&&(Oled_Display_Info.Air_Device.on_off == 0)&&(keyid == 1))
				ret =  TRUE;
			else if((Oled_Display_Info.Air_Device.lock_flage==0)&&(Oled_Display_Info.Air_Device.on_off == 0)&&(keyid == 3)&&(KeyPressEvent == Button10sLongEvent))
				ret =  TRUE;
			else if((Oled_Display_Info.Air_Device.lock_flage ==0)&&(Oled_Display_Info.Air_Device.on_off)&&(IsKeyID12356(keyid)))
				ret =  TRUE;
			break;
		}
		case 2:
		{
			if((Oled_Display_Info.FLOOR_Device.lock_flage)&&(keyid == 3))
				ret =  TRUE;
			else if((Oled_Display_Info.FLOOR_Device.lock_flage==0)&&(Oled_Display_Info.FLOOR_Device.on_off == 0)&&(keyid == 1))
				ret =  TRUE;
			else if((Oled_Display_Info.FLOOR_Device.lock_flage==0)&&(Oled_Display_Info.FLOOR_Device.on_off == 0)&&(keyid == 3)&&(KeyPressEvent == Button10sLongEvent))
				ret =  TRUE;
			else if((Oled_Display_Info.FLOOR_Device.lock_flage ==0)&&(Oled_Display_Info.FLOOR_Device.on_off)&&(IsKeyID1356(keyid)))
				ret =  TRUE;
			
			break;
		}
		case 3:
		{
			if((Oled_Display_Info.FAN_Device.lock_flage)&&(keyid == 3))
				ret =  TRUE;
			else if((Oled_Display_Info.FAN_Device.lock_flage==0)&&(Oled_Display_Info.FAN_Device.on_off == 0)&&(keyid == 1))
				ret =  TRUE;
			else if((Oled_Display_Info.FAN_Device.lock_flage==0)&&(Oled_Display_Info.FAN_Device.on_off == 0)&&(keyid == 3)&&(KeyPressEvent == Button10sLongEvent))
				ret =  TRUE;
			else if((Oled_Display_Info.FAN_Device.lock_flage ==0)&&(Oled_Display_Info.FAN_Device.on_off)&&(IsKeyID123(keyid)))
				ret =  TRUE;
			
			break;
		}
		default:
			break;
	}
	if((Oled_Display_Info.binding_device != 0)&&(keyid == 4))
		ret =  TRUE;
	if(Oled_Display_Info.aging_test_flag != 2)
		ret =  TRUE;
	if((IsLocalConfigMode())&&(IsKeyID1356(keyid) ))
		ret =  TRUE;
	return ret;
}
static void LED_BEEP_Feedback(u8 key_id)
{
	if(  ((Oled_Display_Info.screen_page == 1)&&(Oled_Display_Info.Air_Device.no_disturb_mode == 0  ) )
			||((Oled_Display_Info.screen_page == 2)&&(Oled_Display_Info.FLOOR_Device.no_disturb_mode == 0) )
			||((Oled_Display_Info.screen_page == 3)&&(Oled_Display_Info.FAN_Device.no_disturb_mode == 0)   )  )
		Spake_Start();
		
		if(Oled_Display_Info.net_work_flage == OUT_LINE){
			kNetIndicatorOptTrigger(key_id, 200, 200, 3, 0, 1 );	
		}else{
			kNetIndicatorOptTrigger(key_id, 200, 200, 1, 0, 1 );			
		}
}
void KeyProcess_Handler_Callbacks(u8 key_id,u8 KeyPressEvent)
{
	//15min-4hϻڼ䲻ܲ
	if((Oled_Display_Info.aging_test_flag == 1)||(First_Exit_Factory_Mode == 1))   
		return;
	
	if((KeyPressEvent == ButtonShortEvent)||(KeyPressEvent == ButtonLongEvent))
	{
		Detect_Human_Dispaly();
		if(IsLcdEnterScreenSave())							//Ϣ״̬ôδֻѣЧ
		{
			Reload_Save_Time();	
			Detect_Human_Dispaly();                        //cannot delete
			return;
		}
		Reload_Save_Time();	
	}
	//Ч
	if(Is_Valided_Key(Oled_Display_Info.screen_page,key_id,KeyPressEvent))
	{
		if((KeyPressEvent != Button10sLongEvent)&&(KeyPressEvent != ButtonLongEvent)&&(KeyPressEvent != Button0_5sLongEvent))
			LED_BEEP_Feedback(key_id);
	}
	
	if(LongLongPress10s_Handler(key_id,KeyPressEvent))
		return;
	
	//ģʽ
	if(Key_Operate_Config_Operation(key_id,KeyPressEvent)||(KeyPressEvent == Button10sLongUpEvent))
	{
		return;
	}
	/******************************************
	ͯ򿪺󣬲
	*******************************************/
	if(  ((Oled_Display_Info.screen_page == 1)&&(Oled_Display_Info.Air_Device.lock_flage)) 
	   ||((Oled_Display_Info.screen_page == 2)&&(Oled_Display_Info.FLOOR_Device.lock_flage)) 
	   ||((Oled_Display_Info.screen_page == 3)&&(Oled_Display_Info.FAN_Device.lock_flage)) )
	{
		if((key_id == 3)&&(KeyPressEvent == ButtonLongEvent))
		{
			//ػµĽ
			if( (Oled_Display_Info.screen_page == 1)&&(Oled_Display_Info.Air_Device.on_off == 0))
			{
				Control_ChildLock_Onoff(AIR_CONDITION,0);	
				return	;
			}
			else if((Oled_Display_Info.FLOOR_Device.lock_flage)&&(Oled_Display_Info.FLOOR_Device.on_off == 0))
			{
				Control_ChildLock_Onoff(FLOOR_HEATING,0);
				return	;
			}
			else if((Oled_Display_Info.FAN_Device.lock_flage)&&(Oled_Display_Info.FAN_Device.on_off == 0))
			{
				Control_ChildLock_Onoff(FAN,0);	
				return	;
			}
					
		}else{
			if( ((key_id == 3)&&(KeyPressEvent == ButtonShortEvent)) ||
			    (IsKeyID12356(key_id))||( (key_id == 4)&&(!Oled_Display_Info.binding_device)) )
			{
				LCDShowTemp_state_t.LCD_place = CHILD_LOCK_DISPLAY;	
				LCDShowTemp_state_t.LCD_state = ON;
				LcdShowCTR(LCDShowTemp_state_t);
				
				LCDShowTemp_state_t.LCD_state = FLASHING;
				LCDShowTemp_state_t.LCD_display_count = 6;
				LCDShowTemp_state_t.LCD_display_timer = 20;									
				LcdShowCTR(LCDShowTemp_state_t);
				
				ChildLockLedFlash();						//led 3˸
				return;
			}
		}
	}
	/******************************************
	ǵڷٰ£֮ǰڷ˸
	*******************************************/
	if( (gKey_Press_Info.adjust_fan_speed_status)&&((key_id == 1)||(key_id == 3)||(key_id == 4)))    
	{
		delay_confirm_fan_speed();
	}
	switch(key_id)
	{
		case 1:
			KEY1_Botton_Process_Handler(KeyPressEvent);
			break;
		case 2:
			KEY2_Botton_Process_Handler(KeyPressEvent);
			break;
		case 3:
			KEY3_Botton_Process_Handler(KeyPressEvent);
			break;
		case 4:
			KEY4_Botton_Process_Handler(KeyPressEvent);
			break;
		case 5:
			KEY5_Botton_Process_Handler(KeyPressEvent);
			break;
		case 6:
			KEY6_Botton_Process_Handler(KeyPressEvent);
			break;
		default:
			break;
	}
}
void Delay_Power_Off_Control(u8 control_type,u16 flashing_time_ms,u16 flash_interval_time_ms,u8 show_num)
{
	LCDShowTemp_state_t.LCD_place = DELAY_OFF_TIME_DISPLAY;
	if(control_type == FLASHING)
	{
		
		LCDShowTemp_state_t.LCD_state = FLASHING;
		if(flash_interval_time_ms)
			LCDShowTemp_state_t.LCD_display_count  = flashing_time_ms/flash_interval_time_ms;								//15s
		else
			LCDShowTemp_state_t.LCD_display_count  = 0;
		LCDShowTemp_state_t.LCD_display_timer  = flash_interval_time_ms/10;								
	}
	else 
	{
		LCDShowTemp_state_t.LCD_state = control_type;
		LCDShowTemp_state_t.LCD_display_count  = 0;								
		LCDShowTemp_state_t.LCD_display_timer  = 0;	
	}
	LCDShowTemp_state_t.LCD_code_data = show_num;
	LcdShowCTR(LCDShowTemp_state_t);
}
void Delay_OFF_Rel_Display(u8 stop_flash,u8 delay_timer,u8 dispaly_data,u8 H_char,u8 bell_char,u8 setting_time_char)
{
	if(stop_flash)
	{
		Delay_Power_Off_Control(DFLASHING,NULL,NULL,dispaly_data);
	}
	
	if(delay_timer)
	{
		if(dispaly_data >0)
			Delay_Power_Off_Control(ON,NULL,NULL,dispaly_data);
	}
	else
	{
		Delay_Power_Off_Control(OFF,NULL,NULL,dispaly_data);
		
	
	}
	
	if(bell_char){	
		//ʾ
		LCDShowTemp_state_t.LCD_place = SETTING_TIMER_DISPLAY;		
		LCDShowTemp_state_t.LCD_state = ON;
		
	}else{
		LCDShowTemp_state_t.LCD_place = SETTING_TIMER_DISPLAY;		
		LCDShowTemp_state_t.LCD_state = OFF;
	}
	LcdShowCTR(LCDShowTemp_state_t);
					
	if(setting_time_char)
	{	
		//ʾ趨ʱַͼ
		LCDShowTemp_state_t.LCD_place = SETTING_TIMER_CHAR_DISPLAY;		
		LCDShowTemp_state_t.LCD_state = ON;
		
	}else{
		LCDShowTemp_state_t.LCD_place = SETTING_TIMER_CHAR_DISPLAY;		
		LCDShowTemp_state_t.LCD_state = OFF;
	}
	LcdShowCTR(LCDShowTemp_state_t);
	
	//رտʾƶַ
	LCDShowTemp_state_t.LCD_place = UPPER_TEMPER_UNIT_DISPLAY;		
	LCDShowTemp_state_t.LCD_state = OFF;
	LcdShowCTR(LCDShowTemp_state_t);
}
void Calib_Temp_Control(u8 control_type,u16 flashing_time_ms,u16 flash_interval_time_ms,u16 show_num)
{
	LCDShowTemp_state_t.LCD_place = CALIBRATE_TEMPER_DISPLAY;
	if(control_type == FLASHING)
	{
		
		LCDShowTemp_state_t.LCD_state = FLASHING;
		if(flash_interval_time_ms)
			LCDShowTemp_state_t.LCD_display_count  = flashing_time_ms/flash_interval_time_ms;								//15s
		else
			LCDShowTemp_state_t.LCD_display_count = 0;
		LCDShowTemp_state_t.LCD_display_timer  = flash_interval_time_ms/10;								
	}
	else 
	{
		LCDShowTemp_state_t.LCD_state = control_type;
		LCDShowTemp_state_t.LCD_display_count  = 0;								
		LCDShowTemp_state_t.LCD_display_timer  = 0;	
	}
	LCDShowTemp_state_t.LCD_code_data = show_num;
	LcdShowCTR(LCDShowTemp_state_t);
}
void Control_OnOff_handler(u8 device_type,u8 onoff)
{
	switch(device_type)
	{
		case AIR_CONDITION:
		{
			if(onoff == 1)
			{
				Oled_Display_Info.Air_Device.on_off = 1;
				Oled_Display_whole();
			}
			else
			{
				PowerOff();
				Oled_Display_Info.Air_Device.on_off = 0;
				if(Oled_Display_Info.Air_Device.power_off_time >0)
				{
					Oled_Display_Info.Air_Device.power_off_time = 0;
					Oled_Display_Info.Air_Device.power_off_flage = 0;						
					sKey_Operation[0].record_adjust_delay_off 		= 0;
				}
			}
		}
			break;
		case FLOOR_HEATING:
		{
			if(onoff == 1)
			{
				Oled_Display_whole();
				Oled_Display_Info.FLOOR_Device.on_off = 1;
				#if DEVICE_TYPE_FLOOR_HEATING
				Tap_Status_Scan_Task_Start();	
				#endif
			}
			else
			{
				PowerOff();
				#if DEVICE_TYPE_FLOOR_HEATING
				Relay_Action(0x01,0x00);																//ƷŴ
				#endif
				Oled_Display_Info.FLOOR_Device.on_off = 0;
				if(Oled_Display_Info.FLOOR_Device.power_off_time >0)
				{
					Oled_Display_Info.FLOOR_Device.power_off_time = 0;	
					Oled_Display_Info.FLOOR_Device.power_off_flage = 0;				
					sKey_Operation[1].record_adjust_delay_off 		= 0;
				}
			}
		}
			break;
		case FAN:
		{
			if(onoff == 1)
			{
				Oled_Display_whole();
				Oled_Display_Info.FAN_Device.on_off = 1;
				#if DEVICE_TYPE_FAN
					Fan_PassbyONOFF_By_Mode_Trans(Oled_Display_Info.FAN_Device.system_type,1);
					Fan_Speed_Control(Oled_Display_Info.FAN_Device.wind_speed);
				#endif
			}
			else
			{
				PowerOff();
				Oled_Display_Info.FAN_Device.on_off = 0;
				#if DEVICE_TYPE_FAN
				Relay_Action(0x0F,0x00);							//رȫ̵
				#endif
				if(Oled_Display_Info.FAN_Device.power_off_time >0)
				{
					Oled_Display_Info.FAN_Device.power_off_time = 0;
					Oled_Display_Info.FAN_Device.power_off_flage = 0;
					sKey_Operation[2].record_adjust_delay_off 		= 0;
				}
			}
		
		}
			break;
	}
}
static void KEY1_Botton_Process_Handler(u8 KeyPressEvent)
{
	switch(KeyPressEvent)
	{
		case ButtonShortEvent:
		{
			if(Oled_Display_Info.screen_page == 1)															//յҳ
			{
				if(Oled_Display_Info.Air_Device.on_off)
				{	
					Control_OnOff_handler(AIR_CONDITION,0);
					#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
						delay_control_onoff_start();
					#else
						Start_Delay_Report_Event(1);														//״̬ı֪ͨ
					#endif	
					
				}
				else
				{
					Control_OnOff_handler(AIR_CONDITION,1);
					
					#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
						delay_control_onoff_start();
					#else
						Start_Delay_Report_Event(1);	//״̬ı֪ͨ
					#endif	
				}
			}
			else if(Oled_Display_Info.screen_page == 2)
			{
				if(Oled_Display_Info.FLOOR_Device.on_off)
				{
					Control_OnOff_handler(FLOOR_HEATING,0);													//ƷŹر					
				}
				else
				{
					Control_OnOff_handler(FLOOR_HEATING,1);													
				}
				Start_Delay_Report_Event(2);	
			}
			else if(Oled_Display_Info.screen_page == 3)
			{
				if(Oled_Display_Info.FAN_Device.on_off)
				{
					Control_OnOff_handler(FAN,0);										//״̬ϱ
				}
				else
				{
					Control_OnOff_handler(FAN,1);		
				}
				Start_Delay_Report_Event(3);
			}
		}
			break;
		case ButtonLongEvent:
		{
			u8 arg[2] = {0};
			static u8 firstLongPressFlg = 0;
			//15minǰϻܲ
			if(Oled_Display_Info.aging_test_flag != 2)   
				break;
			if(Oled_Display_Info.net_work_flage == OUT_LINE){
				arg[0] = 1;																  //
				Send_Device_Data(0,_OPCODE_SET_NET_STATE,arg,1);
				//printf("join network\r\n");
			}
			else{
				if( ((Oled_Display_Info.local_timer - sKey_Operation[0].operate_last_timer) <=10*1000)&&firstLongPressFlg )
				{
					arg[0] = 0;																  //
					Send_Device_Data(0,_OPCODE_SET_NET_STATE,arg,1);			
					//printf("leave network\r\n");
				}
				else
				{
					firstLongPressFlg = 1;
					//˸һΣʾ̰ͨ
					LCDShowTemp_state_t.LCD_place = ZIGBEE_NET_CAHR_DISPLAY;
					LCDShowTemp_state_t.LCD_state = ON;
					LcdShowCTR(LCDShowTemp_state_t);
					
					LCDShowTemp_state_t.LCD_place = ZIGBEE_NET_CAHR_DISPLAY;
					LCDShowTemp_state_t.LCD_state = FLASHING;
					LCDShowTemp_state_t.LCD_display_count = 2;
					LCDShowTemp_state_t.LCD_display_timer = 20;
					LcdShowCTR(LCDShowTemp_state_t);
				}
			}
			
		}
			break;
		case ButtonLongUpEvent:
		{
			sKey_Operation[0].operate_last_timer = Oled_Display_Info.local_timer;
		}
			break;
		default:
			break;
	}



}
static void KEY2_Botton_Process_Handler(u8 KeyPressEvent)
{
	switch(KeyPressEvent)
	{
		case ButtonShortEvent:
		{
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{
				if(Oled_Display_Info.Air_Device.on_off == 0)     //ģʽܲ
					return;
				
				Fan_Button_Handler();
				
			}
			else if(Oled_Display_Info.screen_page == FAN)
			{
				if(Oled_Display_Info.FAN_Device.on_off == 0)     //ģʽܲ
					return;
				if(Oled_Display_Info.FAN_Device.wind_speed <3)
					Oled_Display_Info.FAN_Device.wind_speed ++;
				else if(Oled_Display_Info.FAN_Device.wind_speed == 3)
					Oled_Display_Info.FAN_Device.wind_speed = 1;
				/********************************************
				ʾǰ
				*********************************************/
				display_wind_speed(Oled_Display_Info.FAN_Device.wind_speed,0);	
				#if DEVICE_TYPE_FAN
				Fan_Speed_Control(Oled_Display_Info.FAN_Device.wind_speed);
				#endif
				Start_Delay_Report_Event(3);	
			}
		}
			break;
		case ButtonLongEvent:
			break;
		case ButtonLongUpEvent:
			break;
		case Button10sLongEvent:
		{
			
		
		}
			break;
		default:
			break;
	}
}
static void KEY3_Botton_Process_Handler(u8 KeyPressEvent)
{
	switch(KeyPressEvent)
	{
		case ButtonShortEvent:
		{
			u8 system_mode_temp = 0;
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{
				if(Oled_Display_Info.Air_Device.on_off == 0)     //ģʽܲ
					return;
				system_mode_temp = System_Mode_Trans(AIR_CONDITION,0);
				Oled_Display_Info.Air_Device.system_type = system_mode_temp;
				
				#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
					delay_control_system_mode_start();
				#else
					Start_Delay_Report_Event(1);
				#endif				
				
			}
			else if(Oled_Display_Info.screen_page == FLOOR_HEATING)
			{
				if(Oled_Display_Info.FLOOR_Device.on_off == 0)     //ģʽܲ
					return;
				system_mode_temp =System_Mode_Trans(FLOOR_HEATING,0);
				
				Oled_Display_Info.FLOOR_Device.system_type = system_mode_temp;
				if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_AUTO)
				{
					Oled_Display_Info.FLOOR_Device.set_temperature = 260;
					
					Display_Set_Temper(Oled_Display_Info.FLOOR_Device.set_temperature);
				}
				
				Start_Delay_Report_Event(2);	
			}
			else if(Oled_Display_Info.screen_page == FAN)
			{
				if(Oled_Display_Info.FAN_Device.on_off == 0)     	//ģʽܲ
					return;
				system_mode_temp = System_Mode_Trans(FAN,0);
				
				Oled_Display_Info.FAN_Device.system_type = system_mode_temp;
				#if DEVICE_TYPE_FAN
				Fan_PassbyONOFF_By_Mode_Trans(system_mode_temp,1);
				#endif
				Start_Delay_Report_Event(3);	
			}
		}
			break;
		case ButtonLongEvent:
		{
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{
				if(Oled_Display_Info.Air_Device.lock_flage)
				{
					Oled_Display_Info.Air_Device.lock_flage = 0;
					Control_ChildLock_Onoff(AIR_CONDITION,Oled_Display_Info.Air_Device.lock_flage);									
				}
				else if((Oled_Display_Info.Air_Device.on_off)&&(Oled_Display_Info.Air_Device.lock_flage == 0))	//ڷ״̬
				{											
					Oled_Display_Info.Air_Device.lock_flage = 1;
					Control_ChildLock_Onoff(AIR_CONDITION,Oled_Display_Info.Air_Device.lock_flage);
				}
			}
			else if(Oled_Display_Info.screen_page == FLOOR_HEATING)
			{
				if(Oled_Display_Info.FLOOR_Device.lock_flage)
				{
					Oled_Display_Info.FLOOR_Device.lock_flage = 0;
					Control_ChildLock_Onoff(FLOOR_HEATING,Oled_Display_Info.FLOOR_Device.lock_flage);
					
				}
				else if((Oled_Display_Info.FLOOR_Device.on_off)&&(Oled_Display_Info.FLOOR_Device.lock_flage == 0))	//ڷ״̬
				{											
					Oled_Display_Info.FLOOR_Device.lock_flage = 1;
					Control_ChildLock_Onoff(FLOOR_HEATING,Oled_Display_Info.FLOOR_Device.lock_flage);
				}
			}
			else if(Oled_Display_Info.screen_page == FAN)
			{
				if(Oled_Display_Info.FAN_Device.lock_flage)
				{
					Oled_Display_Info.FAN_Device.lock_flage = 0;
					Control_ChildLock_Onoff(FAN,Oled_Display_Info.FAN_Device.lock_flage);
				}
				else if((Oled_Display_Info.FAN_Device.on_off)&&(Oled_Display_Info.FAN_Device.lock_flage == 0))	   //ڷ״̬
				{											
					Oled_Display_Info.FAN_Device.lock_flage = 1;
					Control_ChildLock_Onoff(FAN,Oled_Display_Info.FAN_Device.lock_flage);
				}
			}
		}
			break;
		case ButtonLongUpEvent:
			break;
		default:
			break;
	}
}
static void KEY4_Botton_Process_Handler(u8 KeyPressEvent)
{

	switch(KeyPressEvent)
	{
		case ButtonShortEvent:
		{
			u8 bind_device_len = 0;
			u8 device1_type = 0;
			u8 device2_type = 0;
			if(Oled_Display_Info.binding_device == 0)        					//δ
				return;
			delay_confirm_system_control(0);   
			bind_device_len = ((Oled_Display_Info.binding_device&0xF0)>>4);
			device1_type = Oled_Display_Info.binding_device&0x03;
			device2_type = ((Oled_Display_Info.binding_device&0x0C)>>2);
			if(bind_device_len == 1)
			{
				if(Oled_Display_Info.screen_page == Oled_Display_Info.device_type)
				{
					if(device1_type !=0)
						Oled_Display_Info.screen_page = device1_type;
					else
						Oled_Display_Info.screen_page = device2_type;
				}
				else
					Oled_Display_Info.screen_page = Oled_Display_Info.device_type;
			}
			else if(bind_device_len == 2)
			{
				if(Oled_Display_Info.screen_page == Oled_Display_Info.device_type)
					Oled_Display_Info.screen_page = device1_type;
				else if(Oled_Display_Info.screen_page == device1_type)
					Oled_Display_Info.screen_page = device2_type;
				else
					Oled_Display_Info.screen_page = Oled_Display_Info.device_type;
			}
			//ʾеĽ
			BL55072A_Clear();
			display_current_page();
		}	
			break;
		default:
			break;
	}
}
static void KEY5_Botton_Process_Handler(u8 KeyPressEvent)
{
	switch(KeyPressEvent)
	{
		case Button0_5sLongEvent:
		{
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{	
				if(!Oled_Display_Info.Air_Device.on_off)
					return;
				if(Oled_Display_Info.Air_Device.system_type != SYSTEM_MODE_AIR)	
				{
					/**************************************************
					¶
					**************************************************/
					Oled_Display_Info.Air_Device.set_temperature += 10;
					if(Oled_Display_Info.Air_Device.set_temperature >= 300)
						Oled_Display_Info.Air_Device.set_temperature = 300;
					Display_Set_Temper(Oled_Display_Info.Air_Device.set_temperature);       //ʾ¶     
					
					#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
						delay_control_set_temp_start();
					#else
						Start_Delay_Report_Event(1);
					#endif
					 
				}
			}
			else if(Oled_Display_Info.screen_page == FLOOR_HEATING)
			{	
				if(!Oled_Display_Info.FLOOR_Device.on_off)
					return;
				/**************************************************
				¶
				**************************************************/
				if(Oled_Display_Info.FLOOR_Device.system_type!= SYSTEM_MODE_AUTO)
				{
					Oled_Display_Info.FLOOR_Device.set_temperature += 5;
					if(Oled_Display_Info.FLOOR_Device.set_temperature >= 300)
						Oled_Display_Info.FLOOR_Device.set_temperature = 300;
					Display_Set_Temper(Oled_Display_Info.FLOOR_Device.set_temperature);       //ʾ¶
					
					Start_Delay_Report_Event(2);
				}
			}
			break;
		}
		case ButtonShortEvent:
		{
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{		
				if(!Oled_Display_Info.Air_Device.on_off)
					return;
				if(gKey_Press_Info.adjust_fan_speed_status == 1)
				{
					u8  next_speed = 0;
					
					if(Oled_Display_Info.Air_Device.air_cond_type == 2)   //߿֧ߵ+Զ
					{
						if(Oled_Display_Info.Air_Device.system_type != SYSTEM_MODE_DRY)										//Ŀյʪģʽ¸ıЧ
						{
							next_speed = Get_NextOne_By_Current_Speed_Level(1,Oled_Display_Info.Air_Device.wind_speed,0);
							display_wind_speed(next_speed,0);
							Reset_Flash_Time_10s();
							delay_confirm_fan_speed_control(1);
							Oled_Display_Info.Air_Device.wind_speed = next_speed;
							#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
								delay_control_fan_speed_start();
							#else
								Start_Delay_Report_Event(1);
							#endif
							//Control_AIR_CONDITION_By_RS485(AIR_CMD_FAN_SPEED,next_speed);		//ƿյ
						}
					}
					break; 
				}			
				if(Oled_Display_Info.Air_Device.system_type != SYSTEM_MODE_AIR)	
				{
					/**************************************************
					¶
					**************************************************/
					Oled_Display_Info.Air_Device.set_temperature += 10;
					if(Oled_Display_Info.Air_Device.set_temperature >= 300)
						Oled_Display_Info.Air_Device.set_temperature = 300;
					Display_Set_Temper(Oled_Display_Info.Air_Device.set_temperature);       //ʾ¶     
					
					#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
						delay_control_set_temp_start();
					#else
						Start_Delay_Report_Event(1);
					#endif
					 
				}
			}
			else if(Oled_Display_Info.screen_page == FLOOR_HEATING)
			{		
				if(!Oled_Display_Info.FLOOR_Device.on_off)
					return;
				/**************************************************
				¶
				**************************************************/
				if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_AUTO)
				{
					LCDShowTemp_state_t.LCD_place = SYSTEM_AUTO_CHAR_DISPLAY;	
					LCDShowTemp_state_t.LCD_state = ON;
					LcdShowCTR(LCDShowTemp_state_t);
					
					LCDShowTemp_state_t.LCD_state = FLASHING;
					LCDShowTemp_state_t.LCD_display_count  = 2;								//15s
					LCDShowTemp_state_t.LCD_display_timer  = 20;								
					LcdShowCTR(LCDShowTemp_state_t);
				}
				else{
					Oled_Display_Info.FLOOR_Device.set_temperature += 5;
					if(Oled_Display_Info.FLOOR_Device.set_temperature >= 300)
						Oled_Display_Info.FLOOR_Device.set_temperature = 300;
					Display_Set_Temper(Oled_Display_Info.FLOOR_Device.set_temperature);       //ʾ¶
					
					Start_Delay_Report_Event(2);
				}
			}
		}
			break;
//		case ButtonLongEvent:
//			break;
//		case ButtonLongUpEvent:
//			break;
		default:
			break;
	}


}

static void KEY6_Botton_Process_Handler(u8 KeyPressEvent)
{
	switch(KeyPressEvent)
	{
		case Button0_5sLongEvent:
		{
			
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{	
				if(!Oled_Display_Info.Air_Device.on_off)
					return;	
				if(Oled_Display_Info.Air_Device.system_type != SYSTEM_MODE_AIR)	
				{
					/**************************************************
					¶
					**************************************************/
					Oled_Display_Info.Air_Device.set_temperature -= 10;
					if(Oled_Display_Info.Air_Device.set_temperature <= 200)
						Oled_Display_Info.Air_Device.set_temperature = 200;
					Display_Set_Temper(Oled_Display_Info.Air_Device.set_temperature);       //ʾ¶     
					
					#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
						delay_control_set_temp_start();
					#else
						Start_Delay_Report_Event(1);
					#endif
					 
				}
			}
			else if(Oled_Display_Info.screen_page == FLOOR_HEATING)
			{	
				if(!Oled_Display_Info.FLOOR_Device.on_off)
					return;
				/**************************************************
				¶
				**************************************************/
				if(Oled_Display_Info.FLOOR_Device.system_type!= SYSTEM_MODE_AUTO)
				{
					Oled_Display_Info.FLOOR_Device.set_temperature -= 5;
					if(Oled_Display_Info.FLOOR_Device.set_temperature <=160)
						Oled_Display_Info.FLOOR_Device.set_temperature = 160;
					Display_Set_Temper(Oled_Display_Info.FLOOR_Device.set_temperature);       //ʾ¶
					
					Start_Delay_Report_Event(2);
				}
			}
			break;
		}
		case ButtonShortEvent:
		{
			if(Oled_Display_Info.screen_page == AIR_CONDITION)
			{		
				if(!Oled_Display_Info.Air_Device.on_off)
					return;
				if(gKey_Press_Info.adjust_fan_speed_status == 1)
				{
					u8  next_speed = 0;
					if(Oled_Display_Info.Air_Device.air_cond_type == 2)   //߿֧ߵ+Զ
					{				
						if(Oled_Display_Info.Air_Device.system_type != SYSTEM_MODE_DRY)										//Ŀյʪģʽ¸ıЧ
						{
							next_speed = Get_NextOne_By_Current_Speed_Level(0,Oled_Display_Info.Air_Device.wind_speed,0);
							display_wind_speed(next_speed,0);
							Reset_Flash_Time_10s();
							delay_confirm_fan_speed_control(1);
							Oled_Display_Info.Air_Device.wind_speed = next_speed;
							#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
								delay_control_fan_speed_start();
							#else
								Start_Delay_Report_Event(1);
							#endif
						}
					}
					
					break;
				}			
				if(Oled_Display_Info.Air_Device.system_type != SYSTEM_MODE_AIR)	
				{
					Oled_Display_Info.Air_Device.set_temperature -= 10;
					if(Oled_Display_Info.Air_Device.set_temperature <= 200)					//Ŀյ¶ȵڷΧ 17 - 30
						Oled_Display_Info.Air_Device.set_temperature = 200;
					Display_Set_Temper(Oled_Display_Info.Air_Device.set_temperature);       //ʾ¶
						   
					#if  (DEV_TYPE == 0) &&(DEVICE_TYPE_AIR_CONDITION ==1)
						delay_control_set_temp_start();
					#else
						Start_Delay_Report_Event(1);
					#endif
				}
			}
			else if(Oled_Display_Info.screen_page == FLOOR_HEATING)
			{	
				if(!Oled_Display_Info.FLOOR_Device.on_off)
					return;
				if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_AUTO)
				{
					LCDShowTemp_state_t.LCD_place = SYSTEM_AUTO_CHAR_DISPLAY;	
					LCDShowTemp_state_t.LCD_state = ON;
					LcdShowCTR(LCDShowTemp_state_t);
					
					LCDShowTemp_state_t.LCD_state = FLASHING;
					LCDShowTemp_state_t.LCD_display_count  = 2;								//15s
					LCDShowTemp_state_t.LCD_display_timer  = 20;								
					LcdShowCTR(LCDShowTemp_state_t);
				}else{
					Oled_Display_Info.FLOOR_Device.set_temperature -= 5;
					if(Oled_Display_Info.FLOOR_Device.set_temperature <= 160)
						Oled_Display_Info.FLOOR_Device.set_temperature = 160;
					Display_Set_Temper(Oled_Display_Info.FLOOR_Device.set_temperature);       //ʾ¶
					
					Start_Delay_Report_Event(2);	
				}
			}
		}
			break;
		case ButtonLongEvent:
			break;
		case ButtonLongUpEvent:
			break;
		default:
			break;
	}

}

/*********************************************************
ѯһ
plus_or_sub  ӻǼ   1ӣ0С
wind_direct   ʾǰķ
return ¸
**********************************************************/
//u8 Get_NextOne_By_Current_wind_direct(u8 plus_or_sub,u8 wind_direct)
//{
//	u8 next_direct = 0;
//	switch(wind_direct)
//	{
//		case 0:
//		{
//			((plus_or_sub) ? (next_direct = 1):(next_direct = 2));
//		}
//			break;
//		case 1:
//		{
//			((plus_or_sub) ? (next_direct = 2):(next_direct = 0));
//		}
//			break;
//		case 2:
//		{
//			((plus_or_sub) ? (next_direct = 0):(next_direct =1));
//		}
//			break;
//	}
//	return next_direct;
//}
/*********************************************************
ѯһ
plus_or_sub  ӻǼ   1ߣ0С
fan_speed   ʾǰķٵȼ
type_support   ʾַ֧ٵȼ   0 ֧1235  1֧ 01235789
return ¸ٵȼ
**********************************************************/
u8 Get_NextOne_By_Current_Speed_Level(u8 plus_or_sub,u8 fan_speed,u8 type_support)
{
	u8 next_level = 0;
	switch(fan_speed)
	{
		case 0:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 1):(next_level = 2));
			}
			else
			{
				((type_support) ? (next_level = 5):(next_level = 5));
			}
		}
			break;
		case 1:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 7):(next_level = 2));
			}
			else
			{
				((type_support) ? (next_level = 0):(next_level = 5));
			}
		}
			break;
		case 2:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 8):(next_level = 3));
			}
			else
			{
				((type_support) ? (next_level = 7):(next_level = 1));
			}
		}
			break;
		case 3:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 9):(next_level = 5));
			}
			else
			{
				((type_support) ? (next_level = 8):(next_level = 2));
			}
		}
			break;
		case 5:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 0):(next_level = 1));
			}
			else
			{
				((type_support) ? (next_level = 9):(next_level = 3));
			}
		}
			break;
		case 7:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 2):(next_level = 2));
			}
			else
			{
				((type_support) ? (next_level = 1):(next_level = 5));
			}
		
		}
			break;
		case 8:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 3):(next_level = 2));
			}
			else
			{
				((type_support) ? (next_level = 2):(next_level = 5));
			}
		
		}
			break;
		case 9:
		{
			if(plus_or_sub)
			{
				((type_support) ? (next_level = 5):(next_level = 2));
			}
			else
			{
				((type_support) ? (next_level = 3):(next_level = 5));
			}
		}
			break;
	}
	return next_level;
}
#if ( (DEV_TYPE == 1) &&(DEVICE_TYPE_AIR_CONDITION ==1)) ||(DEVICE_TYPE_FLOOR_HEATING) ||(DEVICE_TYPE_FAN)

/******************************************
ſؿƣK1,K2,K3,K4,K5
para :
	control_relay_bits   : bit0-bit5̵ֱ1-6
	onoff_bits		   bit0-bit5̵ֱ1-6״̬
*******************************************/
void Relay_Action(u8 control_relay_bits,u8 onoff_bits)
{
	u8 i = 0;
	for(i = 0;i<6;i++)
	{
		if(control_relay_bits &(1<<i))
		{
			if(onoff_bits &(1<<i))
			{
				Tap_Control.save_tap_status[i]  = 1;
			}
			else{
				Tap_Control.save_tap_status[i]  = 0;
			}
		}
	}
	Save_Tap_Switch();
}
/******************************************
ſ״̬ı䱣棨K1,K2,K3,K4,K5
*******************************************/
void  Save_Tap_Switch(void)
{
    u8 set = 0;
    for(set = 0;set < 6; set ++)
    {				
        if (Tap_Control.save_tap_status[set] == 1)   //
        {
            Tap_Control.tap_to_do[set] = 2;
        }
        else if (Tap_Control.save_tap_status[set] == 0)  //
        {		 
            Tap_Control.tap_to_do[set] = 1;			 
        }			
    } 	
}


/******************************************
ſ״̬ѯ
*******************************************/
void Tap_Switch(void)
{
    if (Tap_Control.tap_end_flage == 0)
    {	
        if (Tap_Control.tap_to_do[Tap_Control.set_tap] != 0)
        {
           Tap_Control. tap_end_flage = 1;			
            EINT_start();	
        }
    }

}
static void Tap_Status_Scan_Task_Start(void)
{
	task_comps[16].task_switch = SWITCH_ON; 
}
static void Tap_Status_Scan_Task_Stop(void)
{
	task_comps[16].task_switch = SWITCH_OFF; 
}
/*
緧ʼ
*/
void Tap_Init(void)
{
	#if DEVICE_TYPE_FLOOR_HEATING
    if(Oled_Display_Info.FLOOR_Device.on_off ==1)  //״̬
    {	
		if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_MANUAL)
        {
			if( Oled_Display_Info.FLOOR_Device.set_temperature - Oled_Display_Info.FLOOR_Device.real_temperature > 20)
			{
				Relay_Action(0x01,0x01);																//̵	
			}
			else if (Oled_Display_Info.FLOOR_Device.real_temperature - Oled_Display_Info.FLOOR_Device.set_temperature > 10)
			{
				Relay_Action(0x01,0x00);																//̵Ͽ		

			}								 			 
        }
		else if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_AUTO)	
		{
			if( 260 - Oled_Display_Info.FLOOR_Device.real_temperature > 20)
			{
				Relay_Action(0x01,0x01);																//̵	
			}
			else if (Oled_Display_Info.FLOOR_Device.real_temperature -260 > 10)
			{
				Relay_Action(0x01,0x00);																//̵Ͽ		

			}	
		}	
		Tap_Status_Scan_Task_Start();
    }
	#elif DEVICE_TYPE_FAN
	if(Oled_Display_Info.FAN_Device.on_off == 1)
	{
		Fan_Speed_Control(Oled_Display_Info.FAN_Device.wind_speed);  //Ĭϴ
		
		if((Oled_Display_Info.FAN_Device.on_off ==1)&&(Oled_Display_Info.aging_test_flag != 1)&&(First_Exit_Factory_Mode == 0))  //״̬û15min-4hϻڼ
		{	 
			Fan_PassbyONOFF_By_Mode_Trans(Oled_Display_Info.FAN_Device.system_type,1);
			Fan_Speed_Control(Oled_Display_Info.FAN_Device.wind_speed);
		}
	}
	#endif
}

/******************************************
//·ģʽл򿪹رͨģʽ
*******************************************/
void Fan_PassbyONOFF_By_Mode_Trans(u8 system_mdoe,u8 reset_count_time)
{
	#if DEVICE_TYPE_FAN
	if(system_mdoe == SYSTEM_MODE_MANUAL)
	{
		Relay_Action(0x08,0x00);
		Tap_Status_Scan_Task_Stop();
	}
	else if(system_mdoe == SYSTEM_MODE_ROLL)
	{
		//״̬ɨ¼
		Tap_Status_Scan_Task_Start();
		Relay_Action(0x08,0x08);
	}
	if(reset_count_time)
	{
		auto_time = 0;			
        auto_type = 0;
	}
	#endif
}
/******************************************
//·л
*******************************************/
void Fan_Speed_Control(u8 wind_speed)
{
	switch(wind_speed)
	{
		//K3
		case WIND_SPEED_LOW:
		{
			Relay_Action(0x07,0x04);
		}
			break;
		//K2
		case WIND_SPEED_MID:
		{
			Relay_Action(0x07,0x02);
		}
			break;
		//K1
		case WIND_SPEED_HIGH:
		{
			Relay_Action(0x07,0x01);
		}
			break;
	}
}
#endif
/******************************************
//緧 ȷ ѵ¶ȿر
*******************************************/
void Tap_Status_Scan(void)
{
	#if DEVICE_TYPE_FLOOR_HEATING
    if((Oled_Display_Info.FLOOR_Device.on_off ==1)&&(Oled_Display_Info.aging_test_flag != 1)&&(First_Exit_Factory_Mode ==0))  //״̬û15min-4hϻڼ
    {	 
        if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_MANUAL)
        {
			if( Oled_Display_Info.FLOOR_Device.set_temperature - Oled_Display_Info.FLOOR_Device.real_temperature > 20)
			{
				Relay_Action(0x01,0x01);																//̵	
			}
			else if (Oled_Display_Info.FLOOR_Device.real_temperature - Oled_Display_Info.FLOOR_Device.set_temperature > 10)
			{
				Relay_Action(0x01,0x00);																//̵Ͽ		

			}								 			 
        }
		else if(Oled_Display_Info.FLOOR_Device.system_type == SYSTEM_MODE_AUTO)	
		{
			if( 260 - Oled_Display_Info.FLOOR_Device.real_temperature > 20)
			{
				Relay_Action(0x01,0x01);																//̵	
			}
			else if (Oled_Display_Info.FLOOR_Device.real_temperature -260 > 10)
			{
				Relay_Action(0x01,0x00);																//̵Ͽ		

			}	
		}			
    }
	#elif DEVICE_TYPE_FAN
	if((Oled_Display_Info.FAN_Device.on_off ==1)&&(Oled_Display_Info.aging_test_flag != 1)&&(First_Exit_Factory_Mode ==0))  //״̬û15min-4hϻڼ
    {	 
		if(Oled_Display_Info.FAN_Device.system_type != SYSTEM_MODE_ROLL)
			return;
        auto_time ++;
        if(auto_time >= 20)
        {
            auto_time = 0;			
            auto_type ++;
            if (auto_type > 2)
            {
                auto_type = 0;
            }
        }
        switch(auto_type)
        {
            case  0:   //ͨ20    K4
            {
               Relay_Action(0x08,0x08);
                break;
            }					 
            case  1:  //ͨر20
            {
                Relay_Action(0x08,0x00);					 
                break;
            }	
            case  2:  //ͨر20
            {
                Relay_Action(0x08,0x00);								 
                break;
            }
            default :
            {
                break;    
            }            
        }	
    }
	#endif
}
/******************************************
//ͯ
*******************************************/
void Control_ChildLock_Onoff(u8 device_type,u8 onoff)
{
	if(device_type == AIR_CONDITION)
	{
		LCDShowTemp_state_t.LCD_place = CHILD_LOCK_DISPLAY;	
		if(onoff)																	//״̬ɽ
		{
			Oled_Display_Info.Air_Device.lock_flage = 1;
			Operate_Led_Button(AIR_CONDITION,1);									// ֻʾ'M'
			LCDShowTemp_state_t.LCD_state = ON;	
				
		}
		else{	
			Oled_Display_Info.Air_Device.lock_flage = 0;
			if(Oled_Display_Info.Air_Device.on_off)
				Operate_Led_Button(AIR_CONDITION,2);									
			else 
				Operate_Led_Button(AIR_CONDITION,3);
			LCDShowTemp_state_t.LCD_state = OFF;	
		}
		LcdShowCTR(LCDShowTemp_state_t);
		
		Start_Delay_Report_Event(1);	
	}
	else if(device_type == FLOOR_HEATING)
	{
		LCDShowTemp_state_t.LCD_place = CHILD_LOCK_DISPLAY;	
		if(onoff)																	//״̬ɽ
		{
			Oled_Display_Info.FLOOR_Device.lock_flage = 1;
			Operate_Led_Button(FLOOR_HEATING,1);									// ֻʾ'M'
			LCDShowTemp_state_t.LCD_state = ON;		
		}
		else{	
			Oled_Display_Info.FLOOR_Device.lock_flage = 0;
			if(Oled_Display_Info.FLOOR_Device.on_off)
				Operate_Led_Button(FLOOR_HEATING,2);									
			else 
				Operate_Led_Button(FLOOR_HEATING,3);			
			LCDShowTemp_state_t.LCD_state = OFF;	
		}
		LcdShowCTR(LCDShowTemp_state_t);
		
		Start_Delay_Report_Event(2);
	}
	else if(device_type == FAN)
	{
		LCDShowTemp_state_t.LCD_place = CHILD_LOCK_DISPLAY;	
		if(onoff)																	//״̬ɽ
		{
			Oled_Display_Info.FAN_Device.lock_flage = 1;
			Operate_Led_Button(FAN,1);												// ֻʾ'M'
			LCDShowTemp_state_t.LCD_state = ON;	
				
		}
		else{	
			Oled_Display_Info.FAN_Device.lock_flage = 0;
			if(Oled_Display_Info.FAN_Device.on_off)
				Operate_Led_Button(FAN,2);									
			else 
				Operate_Led_Button(FAN,3);			
			LCDShowTemp_state_t.LCD_state = OFF;		
		}
		LcdShowCTR(LCDShowTemp_state_t);
		
		Start_Delay_Report_Event(3);
	}
	save_data();
}
